/*******************************************************************************
 * FoxCustomizationNode_AvatarSkin generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxCustomizationNode_AvatarSkin extends FoxCustomizationNode_Base within FoxArmoryUI
    config(UI);

struct native AvatarInfo
{
    var FoxDataProvider_Avatar AvatarProvider;
    var int Index;

    structdefaultproperties
    {
        AvatarProvider=none
        Index=0
    }
};

var transient array<AvatarInfo> AvatarInfoArray;

function Initialize(optional bool bSelectEquipped)
{
    local array<FoxDataProvider_Avatar> NewAvatarArray;
    local int I;
    local ScrollerListEntry NewScrollerListEntry;
    local AvatarInfo NewAvatarInfo;

    bSelectEquipped = true;
    super.Initialize(bSelectEquipped);
    Outer.CustomItemType = 21;
    // End:0x51
    if(bSelectEquipped)
    {
        ResetSelectedLoadout();
    }
    Outer.SelectedScrollerIndex = 0;
    AvatarInfoArray.Length = 0;
    ScrollerEntries.Length = 0;
    NewAvatarArray = Outer.LoadoutInfo.UnlockablesDataStore.AvatarProviderArray;
    EquippedUnlockID = ((Outer.CachedAvatarIndex != -1) ? Outer.LoadoutInfo.UnlockablesDataStore.AvatarProviderArray[Outer.CachedAvatarIndex].UnlockID : 0);
    I = 0;
    J0x197:
    // End:0x396 [Loop If]
    if(I < NewAvatarArray.Length)
    {
        NewAvatarInfo.AvatarProvider = NewAvatarArray[I];
        // End:0x388
        if((NewAvatarArray[I].VersionNumber > -1) && SetScrollerEntry(NewScrollerListEntry, NewAvatarInfo.AvatarProvider.UnlockID))
        {
            NewScrollerListEntry.VersionNumber = NewAvatarInfo.AvatarProvider.VersionNumber;
            NewAvatarInfo.Index = I;
            NewScrollerListEntry.InsertIndex = AvatarInfoArray.Length;
            // End:0x35C
            if(NewScrollerListEntry.bEquipped)
            {
                SetEquipped(NewScrollerListEntry, bSelectEquipped);
                Outer.SelectedScrollerIndex = I;
            }
            ScrollerEntries.AddItem(NewScrollerListEntry);
            AvatarInfoArray.AddItem(NewAvatarInfo);
        }
        ++ I;
        // [Loop Continue]
        goto J0x197;
    }
    SetupScrollerBar(bSelectEquipped);
    //return;    
}

function BuildComponentSlots()
{
    //return;    
}

function ei_changeScrollerIndex(int Index)
{
    local ProfileGearInfo NewGearInfo;

    // End:0xD9
    if((Index >= 0) && Index < ScrollerEntries.Length)
    {
        NewGearInfo = Outer.CachedGearSlot;
        NewGearInfo.AvatarID = AvatarInfoArray[ScrollerEntries[Index].InsertIndex].Index;
        Outer.UpdateCharacterGear(NewGearInfo);
    }
    super.ei_changeScrollerIndex(Index);
    //return;    
}

function ei_ScrollerClicked(string SelectedIndex)
{
    local int NextIndex;

    NextIndex = int(SelectedIndex);
    // End:0x86
    if((NextIndex >= 0) && NextIndex < ScrollerEntries.Length)
    {
        Outer.SelectedScrollerUnlock = ScrollerEntries[NextIndex].UnlockID;
    }
    // End:0xA6
    else
    {
        Outer.SelectedScrollerUnlock = 0;
    }
    super.ei_ScrollerClicked(SelectedIndex);
    //return;    
}

function NodeEquipButtonClicked(string SelectedIndex)
{
    local int AvatarIndex, PrevGearID;

    super.NodeEquipButtonClicked(SelectedIndex);
    AvatarIndex = AvatarInfoArray[ScrollerEntries[Outer.SelectedScrollerIndex].InsertIndex].Index;
    // End:0x2CE
    if((Outer.SelectedScrollerIndex >= 0) && Outer.SelectedScrollerIndex < ScrollerEntries.Length)
    {
        PrevGearID = Outer.CachedAvatarIndex;
        Outer.CachedAvatarIndex = AvatarInfoArray[ScrollerEntries[Outer.SelectedScrollerIndex].InsertIndex].Index;
        EquippedUnlockID = AvatarInfoArray[ScrollerEntries[Outer.SelectedScrollerIndex].InsertIndex].AvatarProvider.UnlockID;
        // End:0x2CB
        if(PrevGearID != Outer.CachedAvatarIndex)
        {
            Outer.CachedGearSlot.AvatarID = Outer.CachedAvatarIndex;
            Outer.CachedGearSlot.BodyCamoID = 0;
            Outer.UpdateCharacterGear(Outer.CachedGearSlot);
        }
    }
    // End:0x3D5
    else
    {
        Outer.CachedGearSlot = Outer.SavedGearSlot;
        Outer.CachedGearSlot.AvatarID = Outer.SavedAvatarIndex;
        Outer.CachedAvatarIndex = Outer.SavedAvatarIndex;
        Outer.UpdateCharacterGear(Outer.CachedGearSlot);
    }
    Outer.SavedAvatarIndex = AvatarIndex;
    Outer.LastSelectedAvatarIndex = Outer.SavedAvatarIndex;
    Outer.CachedAvatarIndex = Outer.SavedAvatarIndex;
    Outer.CachedGearSlot.AvatarID = Outer.SavedAvatarIndex;
    Outer.SaveGearInfo();
    Outer.UpdateCharacterGear(Outer.CachedGearSlot);
    Outer.LoadoutInfo.SelectAvatarIndex(Outer.SavedAvatarIndex);
    Outer.LoadoutInfo.SetCurrentGear(Outer.SavedGearSlot);
    Outer.Outer.ArmoryItemGrid.as_SetSelectedModIndex(Outer.SetModDataForCamo(Outer.CustomItemType), true);
    //return;    
}

function bool IsPurchased(int ItemId)
{
    return FoxServerConnection(Outer.Outer.Outer.PCOwner.WorldInfo.ServerConn).IsAvatarPurchased(ItemId, FoxPRI(Outer.Outer.Outer.PCOwner.PlayerReplicationInfo));
    //return ReturnValue;    
}

function ResetSelectedLoadout()
{
    Outer.RebuildCachedGearInfo();
    Outer.Outer.ArmoryInfo.ResetSelectedLoadout();
    //return;    
}

defaultproperties
{
    bComponentSlots=true
}